/* jslint evil: true, supernew:true */

define('Purch/Utils/Templating', function() {

    "use strict";

    var Templating = new function () {
        var cache = {};
        this.init = function () {
            this.cache = {};
        };
        /**
         * Render the markup associated to a template and data
         * @param {String} str id of the template or complete string to be transformed
         * @param {Object} data The data object
         * @returns HTML Markup
         */
        this.render = function (str, data) {
            // Figure out if we're getting a template, or if we need to
            // load the template - and be sure to cache the result.
            var fn = !(/\W/.test(str)) ?
                cache[str] = cache[str] ||
                this.render(document.getElementById(str) && document.getElementById(str).innerHTML) :

                // Generate a reusable function that will serve as a template
                // generator (and which will be cached).
                new Function("obj",
                    "var p=[],print=function(){p.push.apply(p,arguments);};" +

                        // Introduce the data as local variables using with(){}
                    "with(obj){p.push('" +

                        // Convert the template into pure JavaScript
                    str
                        .replace(/[\r\t\n]/g, " ")
                        .split("<%").join("\t")
                        .replace(/((^|%>)[^\t]*)'/g, "$1\r")
                        .replace(/\t=(.*?)%>/g, "',$1,'")
                        .split("\t").join("');")
                        .split("%>").join("p.push('")
                        .split("\r").join("\\'")
                        .replace(/data-href/gm, 'href') +
                    "');}return p.join('');");

            // Provide some basic currying to the user
            return data ? fn(data) : fn;
        };
    };

    return Templating;
});