/*jshint -W018 */

define('Purch/Utils/Tracking', ['jquery'], function ($) {

    "use strict";

    var Tracking = function(options) {
        this.options = $.extend({
            targets: '',
            onEvent: 'click',
            gtmDataLayerName: 'dataLayer',
            init: true,
            gtmPushData: function () { return {};}
        }, options || {});

        this.win = window;
        this.gtmDataLayer = this.win[this.options.gtmDataLayerName];

        if (this.options.init === true) {
            this.init();
        }
    };

    Tracking.prototype = {
        init: function() {
            var self = this;
            if ($(self.options.targets).size() === 0) {
                return;
            }
            $('body').on(self.options.onEvent, self.options.targets, $.proxy(self.initHandler, self));
        },

        initHandler: function(ev) {
            var self = this;
            if (self.gtmDataLayer) {
                self.pushToGtm(ev);
            }
        },

        pushToGtm: function (ev) {
            var self = this;
            var gtmPushData = (typeof self.options.gtmPushData === "function") ? self.options.gtmPushData(ev.target) : self.options.gtmPushData;
            if (self.gtmDataLayer) {
                self.gtmDataLayer.push(gtmPushData);
            }
        }
    };

    Tracking.initModule = function(options) {
        return new Tracking(options || {});
    };

    return Tracking;
});